
/**
 * Tacoscript's code generator API, turns an ast into code
 */

"use strict";

var _createClass = require("babel-runtime/helpers/create-class")["default"];

var _classCallCheck = require("babel-runtime/helpers/class-call-check")["default"];

var _interopRequireDefault = require("babel-runtime/helpers/interop-require-default")["default"];

exports.__esModule = true;

var _tacoPrinter = require("./taco-printer");

var _tacoPrinter2 = _interopRequireDefault(_tacoPrinter);

var _detectIndent = require("./detect-indent");

var _detectIndent2 = _interopRequireDefault(_detectIndent);

// TODO: remove this class and just use a function.

var CodeGenerator = (function () {
  function CodeGenerator(ast, opts, code) {
    _classCallCheck(this, CodeGenerator);

    opts = opts || {};
    opts.language = opts.language || 'tacoscript';
    opts.format = opts.format || { preserve: true };
    opts.format.indent = opts.format.indent || _detectIndent2["default"](code);
    if (opts.language === 'javascript') opts.language = 'ecmascript';

    this.printer = this.createPrinter(ast, opts, code);
  }

  CodeGenerator.prototype.createPrinter = function createPrinter(ast, opts, code) {
    return new CodeGenerator.printers[opts.language](ast, opts, code);
  };

  CodeGenerator.prototype.generate = function generate() {
    return this.printer.generate();
  };

  _createClass(CodeGenerator, null, [{
    key: "printers",
    value: {
      'tacoscript': _tacoPrinter2["default"]
    },
    enumerable: true
  }]);

  return CodeGenerator;
})();

exports.CodeGenerator = CodeGenerator;

exports["default"] = function (ast, opts, code) {
  var gen = new CodeGenerator(ast, opts, code);
  return gen.generate();
};